let numberContainer = document.getElementById('numberContainer');
let resultContainer = document.getElementById('resultContainer');

let sumResult = document.getElementById('sumResult');
let productResult = document.getElementById('productResult');

let main = document.querySelector('main');

function sum(event) {
    let numbers = document.querySelectorAll('.number');
    let sum = 0;
    for (let i = 0; i < numbers.length; i++) {
        sum += parseInt(numbers.item(i).value);
    }
    sumResult.innerHTML = sum;
}

function product(event) {
    let numbers = document.querySelectorAll('.number');
    let product = 1;
    for (let i = 0; i < numbers.length; i++) {
        product *= parseInt(numbers.item(i).value);
    }
    productResult.innerHTML = product;
}

function addInput(event) {
    let d = document.createElement('p');
    d.innerHTML =
        'number: <input type="number" name="number" class="number" value="0" /><button class="xButton">X</button> </br>';
    numberContainer.appendChild(d);
    updateResults(event);
}

function remove(event) {
    if (event.target.matches('.xButton')) {
        if (numberContainer.children.length > 2) {
            event.target.parentNode.remove();
        }
    }
    updateResults(event);
}

function addMultipleInputs(event) {
    let amountOfInputs = document.getElementById('multipleInputs');
    for (let i = 0; i < amountOfInputs.value; i++) {
        addInput(event);
    }
}

function updateResults(event) {
    sum(event);
    product(event);
}

function buttonClicked(event) {
    if (event.target.matches('#addMultipleInput')) {
        addMultipleInputs(event);
    }
    if (event.target.matches('#addInput')) {
        addInput(event);
    }
    if (event.target.matches('.xButton')) {
        remove(event);
    }
}

main.addEventListener('input', updateResults);
main.addEventListener('click', buttonClicked);
