let array = [4, 8, 12, 16];

// array.forEach(function(item) {
//     console.log(item);
// });

Array.prototype.selfForEach = function(callback) {
    for (let i = 0; i < this.length; i++) {
        callback(this[i], i, this);
    }
};

array.selfForEach(function(item, index, originalArray) {
    // console.log(item);
    // console.log(index);
    // console.log(originalArray);
});

Array.prototype.selfMap = function(callback) {
    let newArray = [];
    for (let i = 0; i < this.length; i++) {
        newArray.push(callback(this[i], i, this));
    }
    return newArray;
};

let newArray = array.selfMap(function(item, index, originalArray) {
    return item * index;
});

//console.log(newArray);

// let otherArray = [1, 2, 3, 4, 5, 6];

Array.prototype.selfFilter = function(callback) {
    let newArray = [];
    for (let i = 0; i < this.length; i++) {
        if (callback(this[i], i, this)) {
            newArray.push(this[i]);
        }
    }
    return newArray;
};

// let filteredArray = otherArray.selfFilter(function(item, index, originalArray) {
//     return item > 2;
// });

//oef 1
let otherArray = [1, 2, 3, 4, 5, 6];

let filteredArray = otherArray.selfFilter(function(item, index, originalArray) {
    return item % 2 === 0;
});
console.log(filteredArray);

//oef 2
let letterArray = ['a', 'b', 'c'];
let newLetter = letterArray.selfMap(function(item, index, originalArray) {
    return item.toUpperCase();
});
console.log(newLetter);

//oef 3
let numberArray = [1, 2, 3];
let letters = numberArray.selfMap(function(item, index, originalArray) {
    return item.toString();
});
console.log(letters);

//oef 4
let personArray = [
    { name: 'Tom', age: 5 },
    { name: 'Ben', age: 6 },
    { name: 'Charly', age: 2 },
];

let newPersonArray = personArray.selfMap(function(item, index, originalArray) {
    return item.name;
});

console.log(newPersonArray);

//oef 5
let newPersonFilteredArray = personArray.selfFilter(function(
    item,
    index,
    originalArray
) {
    return item.age > 4;
});
console.log(newPersonFilteredArray);

//oef 6

let combination = newPersonFilteredArray.map(function(
    item,
    index,
    originalArray
) {
    return item.name;
});
console.log(combination);

//oef 7

let actorArray = [
    {
        name: 'Angelina Jolie',
        age: 80,
    },
    {
        name: 'Eric Jones',
        age: 2,
    },
    {
        name: 'Paris Hilton',
        age: 5,
    },
    {
        name: 'Kayne West',
        age: 16,
    },
    {
        name: 'Bob Ziroll',
        age: 100,
    },
];

let actorsChanged = actorArray.selfMap(function(item, index, originalArray) {
    if (item.age > 18) {
        return item.name + 'can go to The Matrix';
    }
    return item.name + 'is under age!!';
});
console.log(actorsChanged);

let reduceArray = [1, 2, 3, 4];

let sumOfArray = reduceArray.reduce(function(result, item) {
    return result + item;
}, 0);

console.log(sumOfArray);

Array.prototype.selfReduce = function(callback, initialValue) {
    let result = initialValue;
    for (let i = 0; i < this.length; i++) {
        result = callback(result, this[i], index, this);
    }
    return result;
};

let randomWordArray = ['hier', 'is', 'een', 'array', 'met', 'woorden'];

let reducedString = randomWordArray.reduce(function(result, item) {
    if (!result) return item;

    return result + ' ' + item;
}, '');

console.log(reducedString);

let reducedNumber = actorArray.reduce(function(result, item) {
    return result + item.age;
}, 0);

console.log(reducedNumber);
