const randomWords = [
    'condition',
    'bottom',
    'lineage',
    'trip',
    'reporter',
    'paper',
    'colorful',
    'agent',
    'justify',
    'torture',
    'cap',
    'earthflax',
    'payment',
    'research',
    'picture',
    'garage',
    'honor',
    'memorial',
    'planet',
    'biography',
    'profound',
    'rumor',
    'gear',
    'bedroom',
    'orthodox',
    'penalty',
    'grief',
    'promote',
    'roof',
    'suite',
    'moving',
    'killer',
    'museum',
    'essay',
    'fever',
    'dignity',
    'shadow',
    'enjoy',
    'kill',
    'shy',
    'counter',
    'pawn',
    'button',
    'bullet',
    'skin',
    'rate',
    'shop',
    'consider',
    'other',
    'prospect',
];
const hangManImage = document.querySelector('#image');
const solutionContainer = document.querySelector('#solution-container');
const winOrLoseContainer = document.querySelector('#win-lose-container');
const letterContainer = document.querySelector('#letter-container');
const gameState = {
    word: [],
    hangman: 1,
    turn: 1,
    lettersFound: 0,
    won: false,
    lost: false,
    usedLetters: [],
};

letterContainer.addEventListener('click', checkLetterInWord);
winOrLoseContainer.addEventListener('click', init);
addEventListener('load', init);

function checkLetterInWord(event) {
    if (event.target.matches('.letter')) {
        var letter = event.target.innerHTML.toLowerCase();
        if (
            !gameState.usedLetters.includes(letter) &&
            !gameState.lost &&
            !gameState.won
        ) {
            gameState.usedLetters.push(letter);
            if (gameState.word.includes(letter)) {
                event.target.classList.add('success');
                for (let i = 0; i < gameState.word.length; i++) {
                    if (gameState.word[i] === letter) {
                        solutionContainer.children[
                            i
                        ].innerHTML = letter.toUpperCase();
                        gameState.lettersFound += 1;
                        console.log(gameState.lettersFound);
                        if (gameState.lettersFound == gameState.word.length) {
                            gameState.won = true;
                            winOrLoseContainer.innerHTML = 'You Win!';
                        }
                    }
                }
            } else {
                event.target.classList.add('failed');
                gameState.hangman += 1;
                hangManImage.src =
                    'images/hangman0' + gameState.hangman + '.png';
                if (gameState.hangman === 9) {
                    gameState.lost = true;
                    winOrLoseContainer.innerHTML =
                        'You lose! Word was:' + gameState.word;
                }
            }
        }
    }
}

function init() {
    reset();
    let rand = Math.floor(Math.random() * randomWords.length);
    let lettersArray = randomWords[rand].split('');
    console.log(lettersArray);
    gameState.word = lettersArray;
    updateLetters();
    winOrLoseContainer.innerHTML = '';
}

function updateLetters() {
    //todo make for each (eerst splitten)
    solutionContainer.innerHTML = '';
    for (let i = 0; i < gameState.word.length; ++i) {
        let sl = document.createElement('div');
        sl.classList.add('solution-letter');
        solutionContainer.appendChild(sl);
    }
}

function reset() {
    gameState.word = [];
    gameState.hangman = 1;
    gameState.turn = 1;
    gameState.lettersFound = 0;
    gameState.won = false;
    gameState.lost = false;
    gameState.usedLetters = [];
    hangManImage.src = 'images/hangman01.png';

    for (let i = 0; i < letterContainer.children.length; ++i) {
        letterContainer.children[i].classList.remove('success');
        letterContainer.children[i].classList.remove('failed');
    }
}
