let questions = [
    {
        question: 'Linus Torvalds created Linux and Git.',
        correctAnswer: 'True',
    },
    {
        question:
            'The programming language "Python" is based off a modified version of "JavaScript".',
        correctAnswer: 'False',
    },
    {
        question: 'The logo for Snapchat is a Bell.',
        correctAnswer: 'False',
    },
    {
        question: 'RAM stands for Random Access Memory.',
        correctAnswer: 'True',
    },
    {
        question: '"HTML" stands for Hypertext Markup Language.',
        correctAnswer: 'True',
    },
    {
        question:
            'In most programming languages, the operator ++ is equivalent to the statement "+= 1".',
        correctAnswer: 'True',
    },
    {
        question: 'The Windows 7 operating system has six main editions.',
        correctAnswer: 'True',
    },
    {
        question:
            'The Windows ME operating system was released in the year 2000.',
        correctAnswer: 'True',
    },
    {
        question:
            'The NVidia GTX 1080 gets its name because it can only render at a 1920x1080 screen resolution.',
        correctAnswer: 'False',
    },
    {
        question: 'Linux was first created as an alternative to Windows XP.',
        correctAnswer: 'False',
    },
];

const answerContainer = document.querySelector('#answer-container');
const resultContainer = document.querySelector('#result-container');
let totalCorrect = document.getElementById('total-correct');
const question = document.querySelector('#question');
let gameOver = false;

answerContainer.addEventListener('click', answerClicked);

// https://stackoverflow.com/questions/2450954/how-to-randomize-shuffle-a-javascript-array
function shuffle(array) {
    var currentIndex = array.length,
        temporaryValue,
        randomIndex;

    // While there remain elements to shuffle...
    while (0 !== currentIndex) {
        // Pick a remaining element...
        randomIndex = Math.floor(Math.random() * currentIndex);
        currentIndex -= 1;

        // And swap it with the current element.
        temporaryValue = array[currentIndex];
        array[currentIndex] = array[randomIndex];
        array[randomIndex] = temporaryValue;
    }

    return array;
}

function randomizeQuestions() {
    questions = shuffle(questions);
}

function answerClicked(event) {
    if (!gameOver) {
        if (event.target.matches('#answer-true')) {
            checkAnswer('True');
            let newIndex = parseInt(question.getAttribute('data-index')) + 1;
            question.setAttribute('data-index', newIndex);
        } else if (event.target.matches('#answer-false')) {
            checkAnswer('False');
            let newIndex = parseInt(question.getAttribute('data-index')) + 1;
            question.setAttribute('data-index', newIndex);
        }
        setNewQuestion();
    } else {
        if (event.target.matches('#answer-true')) {
            resetGame();
        }
    }
}

function checkAnswer(answer) {
    let questionIndex = question.getAttribute('data-index');
    if (questions[questionIndex].correct_answer == answer) {
        resultContainer.children[questionIndex].classList.replace(
            'is-dark',
            'is-success'
        );
        totalCorrect.innerText = parseInt(totalCorrect.innerText) + 1;
    } else {
        resultContainer.children[questionIndex].classList.replace(
            'is-dark',
            'is-danger'
        );
    }
}

function addTotalScore() {
    totalCorrect.innerText = parseInt(totalCorrect.innerText) + 1;
}

function init() {
    question.setAttribute('data-index', 0);
    // randomizeQuestions();
    setNewQuestion();
}

function setNewQuestion() {
    index = question.getAttribute('data-index');
    if (index === '10') {
        console.log('new game now');
        question.innerHTML = `Your score was ${totalCorrect.innerText}, would you like to play again?`;
        gameOver = true;
    } else {
        console.log(questions);
        question.innerHTML = questions[index].question;
    }
}

function resetGame() {
    fetchFromAPI();
    let resultArray = Array.from(resultContainer.children);
    resultArray.forEach(function(result) {
        result.classList.replace('is-danger', 'is-dark');
        result.classList.replace('is-success', 'is-dark');
    });
    gameOver = false;
    totalCorrect.innerText = 0;
}

function fetchFromAPI() {
    fetch(
        'https://opentdb.com/api.php?amount=10&category=15&difficulty=medium&type=boolean'
    )
        .then(response => {
            return response.json();
        })
        .then(myJson => {
            questions = myJson.results;
        })
        .then(response => {
            init();
        });
}

fetchFromAPI();
