// jshint esversion: 6

const tryButton = document.querySelector('#try-submit-btn');
const tryInputContainer = document.querySelector('#try-input-container');
const triesContainer = document.querySelector('#tries-container');

let inputValues = [];

const gameState = {
    code: [],
    won: false,
    lost: false,
};

function tryButtonPressed(event) {
    inputValues[0] = tryInputContainer.children[0].value;
    inputValues[1] = tryInputContainer.children[1].value;
    inputValues[2] = tryInputContainer.children[2].value;
    inputValues[3] = tryInputContainer.children[3].value;

    renderInput();
}

function renderInput() {
    let div = document.createElement('div');
    div.innerHTML = `<div class="try">
    <div class="try-option-container">
      <div class="try-option">${inputValues[0]}</div>
      <div class="try-option">${inputValues[1]}</div>
      <div class="try-option">${inputValues[2]}</div>
      <div class="try-option">${inputValues[3]}</div>
    </div>
    <p>Juiste nummer: <span class="correct-color">${checkMatchingNumber()}</span></p>
    <p>Waarvan op de juiste plaats: <span class="correct-place">${checkMatchingLocation()}</span></p>
  </div>
  `;

    triesContainer.appendChild(div);
}

function init() {
    gameState.code = [
        Math.ceil(Math.random() * 6),
        Math.ceil(Math.random() * 6),
        Math.ceil(Math.random() * 6),
        Math.ceil(Math.random() * 6),
    ];
    console.log(gameState.code);
}

function checkMatchingLocation() {
    let counter = 0;
    for (let i = 0; i < 4; ++i) {
        if (gameState.code[i] == inputValues[i]) counter++;
    }
    return counter;
}

function checkMatchingNumber() {
    let counter = 0;
    let code = gameState.code;
    for (let i = 0; i < 4; i++) {
        if (code.includes(inputValues[i])) {
            console.log('test');
            counter++;
        }
    }
    return counter;
}

tryButton.addEventListener('click', tryButtonPressed);

init();
