const character = document.getElementById('character');
const game = document.querySelectorAll('.game');

const gameState = {
    xPos: 100,
    yPos: 505,
    stuck: false,
};

document.onkeydown = keydown;

document.onkeyup = keyup;

function keydown(e) {
    // console.log(e);
    if (e.key === 'ArrowLeft') {
        character.classList.add('reverse');
        character.classList.replace('idle', 'moving');
        move(-1);
    } else if (e.key === 'ArrowRight') {
        character.classList.remove('reverse');
        character.classList.replace('idle', 'moving');
        move(1);
    }
    if (e.key === 'ArrowUp') {
        character.classList.add('jumping');
        gameState.stuck = false;
        setTimeout(function() {
            removeJump();
        }, 1000);
    }
}

function keyup(e) {
    if (e.key === 'ArrowLeft') {
        character.classList.replace('moving', 'idle');
    }
    if (e.key === 'ArrowRight') {
        character.classList.replace('moving', 'idle');
    }
}

function removeJump() {
    character.classList.remove('jumping');
    character.classList.replace('moving', 'idle');
}

function move(direction) {
    // console.log(direction);

    let temp = parseInt(gameState.xPos) + 20 * direction;
    gameState.xPos = temp;
    character.style.left = `${temp}px`;

    if (gameState.xPos > 260 && gameState.xPos < 360) {
        if (!character.classList.contains('jumping')) {
            character.style.top = '460px';
            gameState.stuck = true;
        }
    } else {
        character.style.top = '420px';
    }
    if (parseInt(character.style.left.replace('px', '')) > 1200) {
        character.style.left = 0;
        gameState.xPos = 0;
    }

    if (parseInt(character.style.left.replace('px', '')) < 0) {
        character.style.left = 1200 - 60;
        gameState.xPos = 1200 - 60;
    }
}
